#####################################################
## Compute target moments - 10 periods model
## Authors: Blasutto Fabio and David de la Croix
####################################################

# set the directory to where the files are located
setwd(paste(dire,"\\big base", sep = ""))

#load database 
dico <- as.data.frame(read_excel("Dictionary.xlsx"))
basew  <- as.data.frame(read_excel("Profs-wiki-all.xlsx"))
membersa  <- as.data.frame(read_excel("Italian academies.xlsx"))
membersu  <- as.data.frame(read_excel("Italian universities.xlsx"))

if (unio){members<-membersu}else{members<-rbind(membersa,membersu)}


setwd(dirinput)

#removing people without worldcat
members <- members[members$Worldcat!="NA",]

#remove if field of research is 9 ()
members <- members[members$Field!="9" ,] 

#removing people not yet checked
members <- members[members$Forbidden!=8888,]
members <- members[members$Forbidden!=7777,]
members$PKey<-members$Persons_PKey



#


#Sample
substrRight <- function(x, n){
  substr(x, nchar(x)-n+1, nchar(x))
}

members$nation<-substrRight(members$BirthPlace,3)
if(weak){members<-members[members$WeakLink=="FALSE",]}
if(ita+itas+itan){members<-members[members$nation=="ITA",]}

#members<-members[members$nation=="ITA",]

#remove duplicates
members  <- members[!duplicated(members$Persons_PKey), ]
basew  <- basew[!duplicated(basew), ]



plist<-unique(members$Persons_PKey)


plist2<-plist
#Find the performance in the base generated by the wiki routine

# take the index of quality
members$perfl <- 0
members$bypub <- 0
members$pubp <- 0
members$pubb <- 0
basew$public<- basew$public


#basew.pca <- prcomp(basew[,3:12], center = TRUE,scale. = TRUE)
for (j in plist){
  
  members[members$Persons_PKey==j,"perfl"] <- log(max(c(dico[dico$PKey==j,"publi_by"],1)))  # for individual quality
  
  
  if(notonlyby){
    members[members$Persons_PKey==j,"perfl"] <- log(max(c(dico[dico$PKey==j,"publications"],1)))
  }
  if(wiki){
    members[members$Persons_PKey==j,"perfl"] <- log(max(c(dico[dico$PKey==j,"LengthWikiN"],1)))
  }
  members[members$Persons_PKey==j,"pubb"] <- (c(dico[dico$PKey==j,"publications"]))
  members[members$Persons_PKey==j,"bypub"] <- (c(dico[dico$PKey==j,"publi_by"]))
  members[members$Persons_PKey==j,"pubp"] <- (c(dico[dico$PKey==j,"publi_about"]))
  members[members$Persons_PKey==j,"lat"] <- (c(basew[basew$PKey==j,"Locations_Latitude"]))[1]
}


nbase <- nrow(members)
for (i in (1:nbase)){
  members[i,"refdatel"] <- basew[basew$PKey==members[i,"PKey"],"refdatel"]
}
#North south of italy
if(itan){members<-members[members$lat>=43.8,]}
if(itas){members<-members[members$lat< 43.8,]}


members<-members[!is.na(members$perfl),]


if(!notonlyby){members<-members[members$bypub>0,]}
#if(wiki){members<-members[members$perfl>4.094345,]}

#we remove this guy who started in Spain and ended in Italy after 1750
#members <- members[members$PKey!="Pou-B-1727",]

#Get Nationality
members$nation<-substring(members$BirthPlace,nchar(members$BirthPlace)-2,nchar(members$BirthPlace))






members  <- members[members$refdatel>=1400,]
members  <- members[members$refdatel<1751,]


################################################
# PART 2: COMPUTE THE MOMENTS
################################################

#We consider 10 periods here
members  <- members[members$refdatel>=1400,]
members  <- members[members$refdatel<1750,]




threshold0<- 1400
threshold1 <- 1435
threshold2 <- 1470
threshold3 <- 1505
threshold4<-1540
threshold5<-1575
threshold6<- 1610
threshold7 <- 1645
threshold8 <- 1680
threshold9 <- 1715
threshold10<-1750


members  <- members[members$refdatel>=threshold0,]
members  <- members[!members$refdatel>threshold10,]


members1 <- members[members$refdatel<threshold1,]
members2 <- members[threshold2>members$refdatel & members$refdatel>=threshold1,]
members3 <- members[threshold3>members$refdatel & members$refdatel>=threshold2,]
members4 <- members[threshold4>members$refdatel & members$refdatel>=threshold3,]
members5 <- members[threshold5>members$refdatel & members$refdatel>=threshold4,]
members6 <- members[threshold6>members$refdatel & members$refdatel>=threshold5,]
members7 <- members[threshold7>members$refdatel & members$refdatel>=threshold6,]
members8 <- members[threshold8>members$refdatel & members$refdatel>=threshold7,]
members9 <- members[threshold9>members$refdatel & members$refdatel>=threshold8,]
members10 <-members[members$refdatel>=threshold9,]


memberscensored1 <- members[members$Forbidden<9999 & members$refdatel<threshold1,]
membersnotcensored1 <- members[members$Forbidden==9999 & members$refdatel<threshold1,]

memberscensored2 <- members[members$Forbidden<9999 & 
                              threshold2>members$refdatel & members$refdatel>=threshold1,]
membersnotcensored2 <- members[members$Forbidden==9999 &
                                 threshold2>members$refdatel & members$refdatel>=threshold1,]

memberscensored3 <- members[members$Forbidden<9999 &
                              threshold3>members$refdatel & members$refdatel>=threshold2,]
membersnotcensored3 <- members[members$Forbidden==9999 &
                                 threshold3>members$refdatel & members$refdatel>=threshold2,]

memberscensored4 <- members[members$Forbidden<9999 &
                              threshold4>members$refdatel & members$refdatel>=threshold3,]
membersnotcensored4 <- members[members$Forbidden==9999  &
                                 threshold4>members$refdatel & members$refdatel>=threshold3,]


memberscensored5 <- members[members$Forbidden<9999 & 
                              threshold5>members$refdatel & members$refdatel>=threshold4,]
membersnotcensored5 <- members[members$Forbidden==9999 &
                                 threshold5>members$refdatel & members$refdatel>=threshold4,]

memberscensored6 <- members[members$Forbidden<9999 &
                              threshold6>members$refdatel & members$refdatel>=threshold5,]
membersnotcensored6 <- members[members$Forbidden==9999 &
                                 threshold6>members$refdatel & members$refdatel>=threshold5,]

memberscensored7 <- members[members$Forbidden<9999 &
                              threshold7>members$refdatel & members$refdatel>=threshold6,]
membersnotcensored7 <- members[members$Forbidden==9999  &
                                 threshold7>members$refdatel & members$refdatel>=threshold6,]

memberscensored8 <- members[members$Forbidden<9999 &
                              threshold8>members$refdatel & members$refdatel>=threshold7,]
membersnotcensored8 <- members[members$Forbidden==9999 &
                                 threshold8>members$refdatel & members$refdatel>=threshold7,]

memberscensored9 <- members[members$Forbidden<9999 &
                              threshold9>members$refdatel & members$refdatel>=threshold8,]
membersnotcensored9 <- members[members$Forbidden==9999  &
                                 threshold9>members$refdatel & members$refdatel>=threshold8,]


memberscensored10 <- members[members$Forbidden<9999 & members$refdatel>=threshold9,]
membersnotcensored10 <- members[members$Forbidden==9999 & members$refdatel>=threshold9,]



memberscensored<-members[members$Forbidden<9999,]
membersnotcensored<-members[members$Forbidden>=9999,]




cenq<-c(mean(memberscensored1$perf),
        mean(memberscensored2$perfl),
        mean(memberscensored3$perfl),
        mean(memberscensored4$perfl),
        mean(memberscensored5$perfl),
        mean(memberscensored6$perfl),
        mean(memberscensored7$perfl),
        mean(memberscensored8$perfl),
        mean(memberscensored9$perfl),
        mean(memberscensored10$perfl)
        
        )

ncenq<-c(mean(membersnotcensored1$perf),
         mean(membersnotcensored2$perfl),
         mean(membersnotcensored3$perfl),
         mean(membersnotcensored4$perfl),
         mean(membersnotcensored5$perfl),
         mean(membersnotcensored6$perfl),
         mean(membersnotcensored7$perfl),
         mean(membersnotcensored8$perfl),
         mean(membersnotcensored9$perfl),
         mean(membersnotcensored10$perfl)
         )

q<-c(mean(members1$perf),
     mean(members2$perfl),
     mean(members3$perfl),
     mean(members4$perfl),
     mean(members5$perfl),
     mean(members6$perfl),
     mean(members7$perfl),
     mean(members8$perfl),
     mean(members9$perfl),
     mean(members10$perfl)
     )

mcenq<-c(median(memberscensored1$perf),
         median(memberscensored2$perfl),
         median(memberscensored3$perfl),
         median(memberscensored4$perfl),
         median(memberscensored5$perfl),
         median(memberscensored6$perfl),
         median(memberscensored7$perfl),
         median(memberscensored8$perfl),
         median(memberscensored9$perfl),
         median(memberscensored10$perfl)
         )

mncenq<-c(median(membersnotcensored1$perf),
          median(membersnotcensored2$perfl),
          median(membersnotcensored3$perfl),
          median(membersnotcensored4$perfl),
          median(membersnotcensored5$perfl),
          median(membersnotcensored6$perfl),
          median(membersnotcensored7$perfl),
          median(membersnotcensored8$perfl),
          median(membersnotcensored9$perfl),
          median(membersnotcensored10$perfl)
          
          )

mq<-c(median(members1$perf),
      median(members2$perfl),
      median(members3$perfl),
      median(members4$perfl),
      median(members5$perfl),
      median(members6$perfl),
      median(members7$perfl),
      median(members8$perfl),
      median(members9$perfl),
      median(members10$perfl)
      )



maxperf<-round(max(members$perfl)+0.5,)
maxpeople<-100/2

maxperfd <- 2* maxperf

bv<-(0:maxperfd)
bv<-bv/2


# get the k_t,K^theta_R and m_t*beta_t in the data
Embeta<-numeric(length=leng)
Eqr<-numeric(length=leng)
ENC<-numeric(length=leng)
Eqc<-numeric(length=leng)
Eq<-numeric(length=leng)
Em<-numeric(length=leng)
EqrQ75<-numeric(length=leng)
ENCQ75<-numeric(length=leng)
EqQ75<-numeric(length=leng)
EqrM<-numeric(length=leng)
ENCM<-numeric(length=leng)
EqM<-numeric(length=leng)

for (i in 1:leng) {
  
  nam <- paste("members", i, sep = "")
  namc <- paste("memberscensored", i, sep = "")
  namnc <- paste("membersnotcensored", i, sep = "")
  
  #compute means
  Embeta[i]<-length(get(namc)$perfl)/(length(get(namc)$perfl)+ length(get(namnc)$perfl))
  Eqr[i]=mean(get(namc)$perfl)
  ENC[i]=mean(get(namnc)$perfl)
  Eq[i]=mean(get(nam)$perfl)
  
  #compute medians
  EqrM[i]=median(get(namc)$perfl)
  ENCM[i]=median(get(namnc)$perfl)
  EqM[i]=median(get(nam)$perfl)
  
  #compute 75 percentile
  EqrQ75[i]=quantile(get(namc)$perfl,0.75)
  ENCQ75[i]=quantile(get(namnc)$perfl,0.75)
  EqQ75[i]=quantile(get(nam)$perfl,0.75)
  
  
  
}
rm(nam,namc,namnc)


# get the variance of uality in the first period to get theta
Evar<-var(members1$perfl)

##################################
# get bootstraped CI for graph
##################################
ns<-length(members$perfl)
boots<-numeric(ns)
Bmbeta<-array(,c(leng,nboots))
Bq<-array(,c(leng,nboots))
BNC<-array(,c(leng,nboots))
Bqr<-array(,c(leng,nboots))
BqM<-array(,c(leng,nboots))
BNCM<-array(,c(leng,nboots))
BqrM<-array(,c(leng,nboots))
Bq75<-array(,c(leng,nboots))
BNC75<-array(,c(leng,nboots))
Bqr75<-array(,c(leng,nboots))

#aa<-replicate(nboots, sample(members, ns,replace=TRUE))
for(i in 1:nboots){
  
  
  boots<-as.data.frame(sample(members$Persons_PKey,ns,replace=TRUE))
  memb<-merge(boots,members,
              by.x='sample(members$Persons_PKey, ns, replace = TRUE)',
              by.y='Persons_PKey')
  
  # compute what we need
  #memb<-members[boots%in% members$Persons_PKey]
  #memb<-subset(members,members$Persons_PKey==boots)
  
  #We consider 10 periods here
  members1 <- members[members$refdatel<threshold1,]
  members2 <- members[threshold2>members$refdatel & members$refdatel>=threshold1,]
  members3 <- members[threshold3>members$refdatel & members$refdatel>=threshold2,]
  members4 <- members[threshold4>members$refdatel & members$refdatel>=threshold3,]
  members5 <- members[threshold5>members$refdatel & members$refdatel>=threshold4,]
  members6 <- members[threshold6>members$refdatel & members$refdatel>=threshold5,]
  members7 <- members[threshold7>members$refdatel & members$refdatel>=threshold6,]
  members8 <- members[threshold8>members$refdatel & members$refdatel>=threshold7,]
  members9 <- members[threshold9>members$refdatel & members$refdatel>=threshold8,]
  members10 <-members[members$refdatel>=threshold9,]
  
  
  memberscensored1 <- members[members$Forbidden<9999 & members$refdatel<threshold1,]
  membersnotcensored1 <- members[members$Forbidden==9999 & members$refdatel<threshold1,]
  
  memberscensored2 <- members[members$Forbidden<9999 & 
                                threshold2>members$refdatel & members$refdatel>=threshold1,]
  membersnotcensored2 <- members[members$Forbidden==9999 &
                                   threshold2>members$refdatel & members$refdatel>=threshold1,]
  
  memberscensored3 <- members[members$Forbidden<9999 &
                                threshold3>members$refdatel & members$refdatel>=threshold2,]
  membersnotcensored3 <- members[members$Forbidden==9999 &
                                   threshold3>members$refdatel & members$refdatel>=threshold2,]
  
  memberscensored4 <- members[members$Forbidden<9999 &
                                threshold4>members$refdatel & members$refdatel>=threshold3,]
  membersnotcensored4 <- members[members$Forbidden==9999  &
                                   threshold4>members$refdatel & members$refdatel>=threshold3,]
  
  
  memberscensored5 <- members[members$Forbidden<9999 & 
                                threshold5>members$refdatel & members$refdatel>=threshold4,]
  membersnotcensored5 <- members[members$Forbidden==9999 &
                                   threshold5>members$refdatel & members$refdatel>=threshold4,]
  
  memberscensored6 <- members[members$Forbidden<9999 &
                                threshold6>members$refdatel & members$refdatel>=threshold5,]
  membersnotcensored6 <- members[members$Forbidden==9999 &
                                   threshold6>members$refdatel & members$refdatel>=threshold5,]
  
  memberscensored7 <- members[members$Forbidden<9999 &
                                threshold7>members$refdatel & members$refdatel>=threshold6,]
  membersnotcensored7 <- members[members$Forbidden==9999  &
                                   threshold7>members$refdatel & members$refdatel>=threshold6,]
  
  memberscensored8 <- members[members$Forbidden<9999 &
                                threshold8>members$refdatel & members$refdatel>=threshold7,]
  membersnotcensored8 <- members[members$Forbidden==9999 &
                                   threshold8>members$refdatel & members$refdatel>=threshold7,]
  
  memberscensored9 <- members[members$Forbidden<9999 &
                                threshold9>members$refdatel & members$refdatel>=threshold8,]
  membersnotcensored9 <- members[members$Forbidden==9999  &
                                   threshold9>members$refdatel & members$refdatel>=threshold8,]
  
  
  memberscensored10 <- members[members$Forbidden<9999 & members$refdatel>=threshold9,]
  membersnotcensored10 <- members[members$Forbidden==9999 & members$refdatel>=threshold9,]
  
  memberscensored <- memb[memb$Forbidden<9999 ,]
  
  
  #the moments now
  for(j in 1:leng){
    
    nam <- paste("members", j, sep = "")
    namc <- paste("memberscensored", j, sep = "")
    namnc <- paste("membersnotcensored", j, sep = "")
    
    Bmbeta[j,i]<-length(get(namc)$perfl)/(length(get(namc)$perfl)+ length(get(namnc)$perfl))
    Bqr[j,i]=mean(get(namc)$perfl)
    Bq[j,i]=mean(get(nam)$perfl)
    BNC[j,i]=mean(get(namnc)$perfl)
    BqrM[j,i]=median(get(namc)$perfl)
    BqM[j,i]=median(get(nam)$perfl)
    BNCM[j,i]=median(get(namnc)$perfl)
    Bqr75[j,i]=quantile(get(namc)$perfl,0.75)
    Bq75[j,i]=quantile(get(nam)$perfl,0.75)
    BNC75[j,i]=quantile(get(namnc)$perfl,0.75)
    
  }}

#get finally the CI
CImbeta<-array(,c(2,leng))
CIq<-array(,c(2,leng))
CIqr<-array(,c(2,leng))
CINC<-array(,c(2,leng))
CImbeta75<-array(,c(2,leng))
CIq75<-array(,c(2,leng))
CIqr75<-array(,c(2,leng))
CINC75<-array(,c(2,leng))

for(j in 1:5){
  CImbeta[,j]<-quantile(Bmbeta[j,],c(0.025,0.975))
  CIq[,j]<-quantile(BqM[j,],c(0.025,0.975))
  CIqr[,j]<-quantile(BqrM[j,],c(0.025,0.975))
  CINC[,j]<-quantile(BNCM[j,],c(0.025,0.975))
  CIq75[,j]<-quantile(Bq75[j,],c(0.025,0.975))
  CIqr75[,j]<-quantile(Bqr75[j,],c(0.025,0.975))
  CINC75[,j]<-quantile(BNC75[j,],c(0.025,0.975))
  
}

#Save and store the results
Bqc<-BNC
Bm<-Bmbeta
momentss<-list("Embeta"=Embeta,"Eqr"=Eqr,
               "ENC"=ENC,"Eqc"=Eqc,
               "Em"=Em,"EqrQ75"=EqrQ75,
               "ENCQ75"=ENCQ75,"EqQ75"=EqQ75,
               "EqrM"=EqrM,"ENCM"=ENCM,
               "Bmbeta"=Bmbeta,"Bqr"=Bqr,
               "BNC"=BNC,"Bqc"=Bqc,
               "Bm"=Bm,"Bqr75"=Bqr75,
               "BNC75"=BNC75,"Bq75"=Bq75,
               "BqrM"=BqrM,"BNCM"=BNCM,
               "EqM"=EqM,"CImbeta"=CImbeta,
               "CIq"=CIq,"CIqr"=CIqr,
               "CINC"=CINC,"CIq75"=CIq75,
               "CIqr75"=CIqr75,"CINC75"=CINC75,
               "Eq"=Eq,
               "GAs"="none")



list.save(momentss, paste0(diroutput,'\\data.Rdata'))  